import {system,world} from "@minecraft/server";

system.runInterval(schedule,2);		

function schedule(){
	let players = world.getAllPlayers();
	for(let player of players){
		let rayBlockCastOptions = {maxDistance:10,includeLiquidBlocks:true,includePassableBlocks:true};
		let rayEntityCastOptions = {maxDistance:10};
		let block = player.getBlockFromViewDirection(rayBlockCastOptions);
		let entity = player.getEntitiesFromViewDirection(rayEntityCastOptions);
		let carriedItem = player.getComponent("inventory").container.getItem(player.selectedSlot);
		let bpStr = "";
		let itemStr = "";
		if(carriedItem){
			try{
			itemStr += `§l§eItem ID: §r§a${carriedItem.typeId}`;
			}catch(e){
			itemStr += `§l§eItem ID: §r§a${carriedItem.typeId}`;	
			}
			if(carriedItem.nameTag){
			itemStr += `\n§l§eItem Nametag: §r§a${carriedItem.nameTag}`;		
			}
			if(carriedItem.hasComponent("durability")){
				let durability = carriedItem.getComponent("durability");
				itemStr += `\n§l§eItem Durability: §r§a${durability.damage}/${durability.maxDurability}`;	
			}
		}
		if(entity.length<=0) {
			if(!block) {
				player.onScreenDisplay.setActionBar(`${itemStr}`);
				continue;
			}			
			let blockProperties = block.permutation.getAllProperties();			
			if(blockProperties.length<=0) bpStr = "§r§anone";
			for(let bpop in blockProperties){
				bpStr += "§r§2" + bpop + ": ";
				bpStr += "§r§a" + blockProperties[bpop] + ", ";
			}
			if(itemStr != ""){
			itemStr += "\n§e----------=*=----------\n";
			}
			player.onScreenDisplay.setActionBar(`${itemStr}§l§eBlock ID: §r§6${block.typeId}\n§l§eBlock States: ${bpStr}`);
		}else{
			let entityId = entity[0].typeId;
			let entityName = entity[0].nameTag;
			if(!entityName) entityName = "§r§anone";			
			let entityHealthComponent = entity[0].getComponent("health");
			let componentStr = "";
			if(entityHealthComponent){
				componentStr += `\n§l§eEntity Health: §r§a${entityHealthComponent.current}/${entityHealthComponent.value}`;
			}
			if(player.isSneaking){
				let entityComponents = entity[0].getComponents();				
				let countCompo = 0;
				for(let component of entityComponents){
					let splitIndex = 0;
					countCompo++;				
					if(component.typeId.includes("tame")) continue;
					componentStr += "\n§r§2" + component.typeId + ":§e[§a";
					for(let compo in entity[0].getComponent(component.typeId)){
						if(compoFilters(compo)) continue;						
						if(splitIndex == 3){
							componentStr += `\n`;
							splitIndex = 0;							
						}
						componentStr += `${compo}: ${entity[0].getComponent(component.typeId)[compo]}, `;
						splitIndex++;
					}
					componentStr += "§e]";			
				}
				for(let count = 4; count<countCompo; count++){
				componentStr += "\n\n";
				}
			}else{
				componentStr += "§a\n...";
			}
			if(itemStr != ""){
			itemStr += "\n§e----------=*=----------\n";
			}
			player.onScreenDisplay.setActionBar(`${itemStr}§l§eEntity ID: §r§6${entityId}\n§l§eEntity Name: §r§a${entityName}${componentStr}`);
		}		
	}
}

function compoFilters(compo){
	let filter = ["set","typeId","tems","leash","grow","filter","Rider","Block","container","Stack","seats"];
	for(let f of filter){		
		if(compo.includes(f)){
			return true;
		}
	}
	return false;
}